package people;

public class PeopleDatabaseFixedImpl implements PeopleDatabase{
    private Person[] persons;
    private int indice;
    public PeopleDatabaseFixedImpl(int max){
	persons = new Person[max];
	indice = 0;
    }

    public void add(Person p){
	if (indice < persons.length){
	    persons[indice] = p;
	    indice ++;
	}
    }
    public Person get(String id){
	Person per = null;
	for (Person p : persons)
	    if (p!= null && p.getUniqueId() == id)
		per = p;
	return per;
    }
    public int getPersonCount(){
	int s = 0;
	for (Person p : persons)
	    if (p != null)
		s++;
	return s;
    }
	
    
    public int getEmployeeCount(){
	int s = 0;
	for (Person p : persons)
	    if (p instanceof Employee)
		s++;
	return s;
    }
    public int getStudentCount(){
	int s = 0;
	for (Person p : persons)
	    if (p instanceof Student)
		s++;
	return s;
    }
    
    public double getStudentAverageAge(){
	if (getStudentCount() != 0){
	    double totalage = 0;
	    for (Person p : persons)
		if (p instanceof Student)
		    totalage+= ((Student)p).getAge();
	    return totalage/getStudentCount();
	}
	else return 0;
    }

    public double getAverageSalary(){
	if (getEmployeeCount() != 0){
	    double s = 0;
	    for (Person p : persons)
		if (p instanceof Employee)
		    s+= ((Employee)p).getSalary();
	    return s/getEmployeeCount();
	}
	else return 0;
	    
    }
    public Person getOldestPerson(){
	Person old = persons[0];
	for (Person p : persons)
	    if ( p != null && p.getAge() > old.getAge())
		old = p;
	return old;
    
    }
    
    public Employee getRichestEmployee(){
	Employee rich = (Employee)persons[0];
	for (Person p : persons)
	    if (p != null && p instanceof Employee){
		Employee e = (Employee)p;
		if (e.getSalary() >= rich.getSalary())
		    rich = e;
		
	    }
	return rich;
    }

}
